Index: less/filename.c
diff -u less/filename.c:1.1.1.14 less/filename.c:1.24
--- less/filename.c:1.1.1.14	Sun Oct 29 02:03:32 2000
+++ less/filename.c	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of compress file treating routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -758,7 +764,31 @@
 	return (gfilename);
 }
 
+#if COMPRESS
 /*
+ * Check a name of input file and easy execution some uncompressing program.
+ */
+	static char*
+easy_lessopen_for_compressedfile(filename)
+	register char *filename;
+{
+	register int length = strlen(filename);
+
+	if (strcmp(".Z", &filename[length - 2]) == 0 ||
+	    strcmp(".z", &filename[length - 2]) == 0)
+		return ("| zcat %s");
+	else if (strcmp(".gz", &filename[length - 3]) == 0 ||
+		 strcmp(".GZ", &filename[length - 3]) == 0)
+		return ("| gzip -cd %s");
+	else if (strcmp(".bz2", &filename[length - 4]) == 0 ||
+		 strcmp(".BZ2", &filename[length - 4]) == 0)
+		return ("| bzip2 -cd %s");
+	else
+		return (NULL);
+}
+#endif
+
+/*
  * See if we should open a "replacement file" 
  * instead of the file we're about to open.
  */
@@ -783,6 +813,9 @@
 		return (NULL);
 	ch_ungetchar(-1);
 	if ((lessopen = lgetenv("LESSOPEN")) == NULL)
+#if COMPRESS
+	    if ((lessopen = easy_lessopen_for_compressedfile(filename)) == NULL)
+#endif
 		return (NULL);
 	if (strcmp(filename, "-") == 0)
 		return (NULL);
Index: less/funcs.h
diff -u less/funcs.h:1.1.1.16 less/funcs.h:1.37
--- less/funcs.h:1.1.1.16	Sun Oct 29 02:19:14 2000
+++ less/funcs.h	Sun Oct 29 02:34:41 2000
@@ -49,9 +49,13 @@
 	public void ch_close ();
 	public int ch_getflags ();
 	public void ch_dump ();
+	public CODESET left_codeset_of_charset ();
+	public CODESET right_codeset_of_charset ();
+	public void init_planeset ();
 	public void init_charset ();
 	public int binary_char ();
 	public int control_char ();
+	public void change_control_char ();
 	public char * prchar ();
 	public void cmd_reset ();
 	public void clear_cmd ();
@@ -63,6 +67,7 @@
 	public int cmd_char ();
 	public int cmd_int ();
 	public char * get_cmdbuf ();
+	public CHARSET * get_cmdcs ();
 	public int in_mca ();
 	public void dispversion ();
 	public int getcc ();
@@ -124,6 +129,7 @@
 	public void store_pos ();
 	public void get_pos ();
 	public void set_open ();
+	public MULBUF * get_mulbuf ();
 	public int opened ();
 	public void hold_ifile ();
 	public int held_ifile ();
@@ -167,12 +173,14 @@
 	public void opt__O ();
 	public void opt_l ();
 	public void opt_k ();
+	public void opt_K ();
 	public void opt_t ();
 	public void opt__T ();
 	public void opt_p ();
 	public void opt__P ();
 	public void opt_b ();
 	public void opt_i ();
+	public void opt_Z ();
 	public void opt__V ();
 	public void opt_D ();
 	public void opt_quote ();
@@ -198,8 +206,13 @@
 	public int  isatty ();
 	public void put_line ();
 	public void flush ();
+	public int putchr_raw ();
+	public void putstr_raw ();
 	public int putchr ();
 	public void putstr ();
+	public int putmchr ();
+	public int putmchrs ();
+	public void putmstr ();
 	public void get_return ();
 	public void error ();
 	public void ierror ();
Index: less/help.c
diff -u less/help.c:1.1.1.11 less/help.c:1.14
--- less/help.c:1.1.1.11	Sun Oct 29 02:19:10 2000
+++ less/help.c	Sun Oct 29 03:45:38 2000
@@ -85,6 +85,8 @@
 ' ',' ',':','x',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','*',' ',' ','E','x','a','m','i','n','e',' ','t','h','e',' ','f','i','r','s','t',' ','(','o','r',' ','_','\b','N','-','t','h',')',' ','f','i','l','e',' ','f','r','o','m',' ','t','h','e',' ','c','o','m','m','a','n','d',' ','l','i','n','e','.','\n',
 ' ',' ',':','d',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','D','e','l','e','t','e',' ','t','h','e',' ','c','u','r','r','e','n','t',' ','f','i','l','e',' ','f','r','o','m',' ','t','h','e',' ','c','o','m','m','a','n','d',' ','l','i','n','e',' ','l','i','s','t','.','\n',
 ' ',' ','=',' ',' ','^','G',' ',' ',':','f',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','P','r','i','n','t',' ','c','u','r','r','e','n','t',' ','f','i','l','e',' ','n','a','m','e','.','\n',
+' ',' ','@',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','R','o','t','a','t','e',' ','t','h','e',' ','c','o','d','e',' ','r','e','c','o','g','n','i','t','i','o','n',' ','m','e','t','h','o','d',' ','o','f',' ','t','h','e',' ','c','u','r','r','e','n','t',' ','f','i','l','e','.','\n',
+' ',' ','V',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','P','r','i','n','t',' ','v','e','r','s','i','o','n',' ','n','u','m','b','e','r',' ','o','f',' ','"','l','e','s','s','"','.','\n',
 ' ','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','-','\n',
 '\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','M','\b','M','I','\b','I','S','\b','S','C','\b','C','E','\b','E','L','\b','L','L','\b','L','A','\b','A','N','\b','N','E','\b','E','O','\b','O','U','\b','U','S','\b','S',' ','C','\b','C','O','\b','O','M','\b','M','M','\b','M','A','\b','A','N','\b','N','D','\b','D','S','\b','S','\n',
@@ -144,6 +146,8 @@
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','D','i','s','p','l','a','y',' ','a',' ','s','t','a','t','u','s',' ','c','o','l','u','m','n',' ','a','t',' ','l','e','f','t',' ','e','d','g','e',' ','o','f',' ','s','c','r','e','e','n','.','\n',
 ' ',' ','-','k',' ','[','_','\b','f','_','\b','i','_','\b','l','_','\b','e',']',' ',' ','.',' ',' ','-','-','l','e','s','s','k','e','y','-','f','i','l','e','=','[','_','\b','f','_','\b','i','_','\b','l','_','\b','e',']','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','U','s','e',' ','a',' ','l','e','s','s','k','e','y',' ','f','i','l','e','.','\n',
+' ',' ','-','K',' ','[','_','\b','c','_','\b','h','_','\b','a','_','\b','r','_','\b','s','_','\b','e','_','\b','t',']',' ',' ','-','-','c','h','a','r','s','e','t','=','[','_','\b','c','_','\b','h','_','\b','a','_','\b','r','_','\b','s','_','\b','e','_','\b','t',']','\n',
+' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','S','p','e','c','i','f','y',' ','c','h','a','r','a','c','t','e','r',' ','s','e','t','.','\n',
 ' ',' ','-','m',' ',' ','-','M',' ',' ','.','.','.','.',' ',' ','-','-','l','o','n','g','-','p','r','o','m','p','t',' ',' ','-','-','L','O','N','G','-','P','R','O','M','P','T','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','S','e','t',' ','p','r','o','m','p','t',' ','s','t','y','l','e','.','\n',
 ' ',' ','-','n',' ',' ','-','N',' ',' ','.','.','.','.',' ',' ','-','-','l','i','n','e','-','n','u','m','b','e','r','s',' ',' ','-','-','L','I','N','E','-','N','U','M','B','E','R','S','\n',
@@ -176,6 +180,8 @@
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','H','i','g','h','l','i','g','h','t',' ','f','i','r','s','t',' ','n','e','w',' ','l','i','n','e',' ','a','f','t','e','r',' ','f','o','r','w','a','r','d','-','s','c','r','e','e','n','.','\n',
 ' ',' ','-','W',' ',' ','.','.','.','.','.','.','.','.',' ',' ','-','-','H','I','L','I','T','E','-','U','N','R','E','A','D','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','H','i','g','h','l','i','g','h','t',' ','f','i','r','s','t',' ','n','e','w',' ','l','i','n','e',' ','a','f','t','e','r',' ','a','n','y',' ','f','o','r','w','a','r','d',' ','m','o','v','e','m','e','n','t','.','\n',
+' ',' ','-',' ',' ',' ','.','.','.','.','.','.','.','.',' ',' ','-','-','m','a','r','k','-','w','r','o','n','g','-','c','h','a','r','\n',
+'\t','\t',' ',' ','D','i','s','p','l','a','y',' ','m','a','r','k',' ','c','h','a','r','a','c','t','e','r',' ','i','n','s','t','e','a','d',' ','o','f',' ','w','r','o','n','g',' ','c','h','a','r','a','c','t','e','r','.','\n',
 ' ',' ','-','x',' ','[','_','\b','N',']',' ',' ','.','.','.','.',' ',' ','-','-','t','a','b','s','=','[','_','\b','N',']','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','S','e','t',' ','t','a','b',' ','s','t','o','p','s','.','\n',
 ' ',' ','-','X',' ',' ','.','.','.','.','.','.','.','.',' ',' ','-','-','n','o','-','i','n','i','t','\n',
@@ -184,6 +190,8 @@
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','F','o','r','w','a','r','d',' ','s','c','r','o','l','l',' ','l','i','m','i','t','.','\n',
 ' ',' ','-','z',' ','[','_','\b','N',']',' ',' ','.','.','.','.',' ',' ','-','-','w','i','n','d','o','w','=','[','_','\b','N',']','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','S','e','t',' ','s','i','z','e',' ','o','f',' ','w','i','n','d','o','w','.','\n',
+' ',' ','-','Z',' ',' ','.','.','.','.','.','.','.','.',' ',' ','-','-','c','h','a','n','g','e','-','p','r','i','o','r','i','t','y','\n',
+'\t','\t',' ',' ','G','i','v','e',' ','p','r','i','o','r','i','t','y',' ','t','o',' ','t','h','e',' ','S','J','I','S',' ','o','v','e','r',' ','t','h','e',' ','U','J','I','S',' ','i','f',' ','y','o','u',' ','u','s','e',' ','J','a','p','a','n','e','s','e','.','\n',
 ' ',' ','-','"',' ','[','_','\b','c','[','_','\b','c',']',']',' ',' ','.',' ',' ','-','-','q','u','o','t','e','s','=','[','_','\b','c','[','_','\b','c',']',']','\n',
 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','S','e','t',' ','s','h','e','l','l',' ','q','u','o','t','e',' ','c','h','a','r','a','c','t','e','r','s','.','\n',
 ' ',' ','-','~',' ',' ','.','.','.','.','.','.','.','.',' ',' ','-','-','t','i','l','d','e','\n',
Index: less/ifile.c
diff -u less/ifile.c:1.1.1.12 less/ifile.c:1.21
--- less/ifile.c:1.1.1.12	Sun Oct 29 02:03:32 2000
+++ less/ifile.c	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -33,6 +39,9 @@
 	int h_hold;			/* Hold count */
 	char h_opened;			/* Has this ifile been opened? */
 	struct scrpos h_scrpos;		/* Saved position within the file */
+#if ISO
+	MULBUF *h_mp;			/* MULBUF for multi bytes character */
+#endif
 };
 
 /*
@@ -46,7 +55,11 @@
  * Anchor for linked list.
  */
 static struct ifile anchor = { &anchor, &anchor, NULL, NULL, 0, 0, '\0',
-				{ NULL_POSITION, 0 } };
+				{ NULL_POSITION, 0 }
+#if ISO
+			       ,NULL
+#endif
+			     };
 static int ifiles = 0;
 
 	static void
@@ -119,6 +132,10 @@
 	p->h_opened = 0;
 	p->h_hold = 0;
 	p->h_filestate = NULL;
+#if ISO
+	p->h_mp = new_multi();
+	init_priority(p->h_mp);
+#endif
 	link_ifile(p, prev);
 	return (p);
 }
@@ -144,6 +161,9 @@
 	p = int_ifile(h);
 	unlink_ifile(p);
 	free(p->h_filename);
+#if ISO
+	free(p->h_mp);
+#endif
 	free(p);
 }
 
@@ -277,6 +297,20 @@
 	struct scrpos *scrpos;
 {
 	*scrpos = int_ifile(ifile)->h_scrpos;
+}
+
+/*
+ * Get the MULBUF associated with a ifile.
+ */
+	public MULBUF *
+get_mulbuf(ifile)
+	IFILE ifile;
+{
+#if ISO
+	if (ifile != NULL)
+		return (int_ifile(ifile)->h_mp);
+#endif
+	return (NULL);
 }
 
 /*
Index: less/input.c
diff -u less/input.c:1.1.1.10 less/input.c:1.25
--- less/input.c:1.1.1.10	Sun Oct 29 02:19:10 2000
+++ less/input.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -33,6 +39,7 @@
 extern int hilite_search;
 extern int size_linebuf;
 #endif
+extern IFILE curr_ifile;
 
 /*
  * Get the next line.
@@ -73,7 +80,7 @@
 		return (NULL_POSITION);
 	}
 
-	prewind();
+	prewind(curr_pos);
 	plinenum(curr_pos);
 	(void) ch_seek(curr_pos);
 
@@ -117,20 +124,33 @@
 				do
 				{
 					c = ch_forw_get();
+#if ISO
+					/*
+					 * Parse all character for finding
+					 * escape sequences.
+					 */
+					parsing_multi(get_mulbuf(curr_ifile),
+						      c);
+#endif
 				} while (c != '\n' && c != EOI);
 				new_pos = ch_tell();
 				endline = TRUE;
 				quit_if_one_screen = FALSE;
 			} else
 			{
+#if ISO
+				new_pos = ch_tell() -
+					get_bufbytes(get_mulbuf(curr_ifile));
+#else
 				new_pos = ch_tell() - 1;
+#endif
 				endline = FALSE;
 			}
 			break;
 		}
 		c = ch_forw_get();
 	}
-	pdone(endline);
+	pdone(endline, new_pos);
 
 	if (squeeze && blankline)
 	{
@@ -265,7 +285,7 @@
 	endline = FALSE;
     loop:
 	begin_new_pos = new_pos;
-	prewind();
+	prewind(new_pos);
 	plinenum(new_pos);
 	(void) ch_seek(new_pos);
 
@@ -295,15 +315,25 @@
 				endline = TRUE;
 				quit_if_one_screen = FALSE;
 				break;
+			}
+#if ISO
+			for (c = get_bufbytes(get_mulbuf(curr_ifile));
+			     --c >= 0; )
+			{
+				(void) ch_back_get();
+				new_pos--;
 			}
-			pdone(0);
+			pdone(0, new_pos);
+#else
+			pdone(0, new_pos);
 			(void) ch_back_get();
 			new_pos--;
+#endif
 			goto loop;
 		}
 	} while (new_pos < curr_pos);
 
-	pdone(endline);
+	pdone(endline, new_pos);
 
 	return (begin_new_pos);
 }
Index: less/less.h
diff -u less/less.h:1.1.1.17 less/less.h:1.52
--- less/less.h:1.1.1.17	Sun Oct 29 02:19:15 2000
+++ less/less.h	Mon Nov 20 02:05:56 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -149,7 +155,7 @@
 /*
  * Flags for open()
  */
-#if MSDOS_COMPILER || OS2
+#if MSDOS_COMPILER || OS2 || __CYGWIN__
 #define	OPEN_READ	(O_RDONLY|O_BINARY)
 #else
 #ifdef _OSK
@@ -179,7 +185,7 @@
 #if MSDOS_COMPILER==MSOFTC
 #define	SET_BINARY(f)	_setmode(f, _O_BINARY);
 #else
-#if MSDOS_COMPILER
+#if MSDOS_COMPILER || __CYGWIN__
 #define	SET_BINARY(f)	setmode(f, O_BINARY)
 #else
 #define	SET_BINARY(f)
@@ -282,6 +288,12 @@
 #define	AT_BLINK	(3)
 #define	AT_INVIS	(4)
 #define	AT_STANDOUT	(5)
+
+/*
+ * Defines for multi character set and code set.
+ */
+#include "multi.h"
+
 
 #if IS_EBCDIC_HOST
 /*
Index: less/less.hlp
diff -u less/less.hlp:1.1.1.12 less/less.hlp:1.16
--- less/less.hlp:1.1.1.12	Sun Oct 29 02:19:18 2000
+++ less/less.hlp	Sun Oct 29 03:45:41 2000
@@ -82,6 +82,8 @@
   :x                *  Examine the first (or _N-th) file from the command line.
   :d                   Delete the current file from the command line list.
   =  ^G  :f            Print current file name.
+  @                    Rotate the code recognition method of the current file.
+  V                    Print version number of "less".
  ---------------------------------------------------------------------------
 
                     MMIISSCCEELLLLAANNEEOOUUSS CCOOMMMMAANNDDSS
@@ -141,6 +143,8 @@
                   Display a status column at left edge of screen.
   -k [_f_i_l_e]  .  --lesskey-file=[_f_i_l_e]
                   Use a lesskey file.
+  -K [_c_h_a_r_s_e_t]  --charset=[_c_h_a_r_s_e_t]
+                  Specify character set.
   -m  -M  ....  --long-prompt  --LONG-PROMPT
                   Set prompt style.
   -n  -N  ....  --line-numbers  --LINE-NUMBERS
@@ -173,6 +177,8 @@
                   Highlight first new line after forward-screen.
   -W  ........  --HILITE-UNREAD
                   Highlight first new line after any forward movement.
+  -   ........  --mark-wrong-char
+		  Display mark character instead of wrong character.
   -x [_N]  ....  --tabs=[_N]
                   Set tab stops.
   -X  ........  --no-init
@@ -181,6 +187,8 @@
                   Forward scroll limit.
   -z [_N]  ....  --window=[_N]
                   Set size of window.
+  -Z  ........  --change-priority
+		  Give priority to the SJIS over the UJIS if you use Japanese.
   -" [_c[_c]]  .  --quotes=[_c[_c]]
                   Set shell quote characters.
   -~  ........  --tilde
Index: less/less.nro
diff -u less/less.nro:1.1.1.17 less/less.nro:1.46
--- less/less.nro:1.1.1.17	Sun Oct 29 02:19:15 2000
+++ less/less.nro	Tue Oct 31 04:30:40 2000
@@ -10,12 +10,14 @@
 .br
 .B "less --version"
 .br
-.B "less [-[+]aBcCdeEfgGiImMnNqQrsSuUVwX]"
+.B "less [-[+]aBcCdeEfgGiImMnNqQrsSuUVWwXZ]"
 .br
 .B "     [-b \fIbufs\fP] [-h \fIlines\fP] [-j \fIline\fP] [-k \fIkeyfile\fP]"
 .br
-.B "     [-{oO} \fIlogfile\fP] [-p \fIpattern\fP] [-P \fIprompt\fP] [-t \fItag\fP]"
+.B "     [-K \fIcharacter set\fP] [-{oO} \fIlogfile\fP]"
 .br
+.B "     [-p \fIpattern\fP] [-P \fIprompt\fP] [-t \fItag\fP]"
+.br
 .B "     [-T \fItagsfile\fP] [-x \fItab\fP] [-y \fIlines\fP] [-[z] \fIlines\fP]"
 .br
 .B "     [+[+]\fIcmd\fP] [--] [\fIfilename\fP]..."
@@ -294,6 +296,13 @@
 If possible, it also prints the length of the file,
 the number of lines in the file
 and the percent of the file above the last displayed line.
+.IP "@"
+Rotate the code recognition method of the current file.
+Enhanced
+.I less
+has 7 methods for recognition, default (which is chosen
+by the JLESSCHARSET environment variable), japanese, ujis, sjis,
+iso8, noconv and none.
 .IP \-
 Followed by one of the command line option letters (see OPTIONS below),
 this will change the setting of that option
@@ -390,6 +399,8 @@
 .I less 
 is running, via the "\-" command.
 .PP
+Options are also taken from the environment variable "LESS" and "JLESS".
+.PP
 Most options may be given in one of two forms: 
 either a dash followed by a single letter,
 or two dashes followed by a long option name.
@@ -421,8 +432,8 @@
 percent signs in the options string by double percent signs.
 .sp
 The environment variable is parsed before the command line,
-so command line options override the LESS environment variable.
-If an option appears in the LESS variable, it can be reset
+so command line options override the LESS and JLESS environment variables.
+If an option appears in the LESS and JLESS variables, it can be reset
 to its default value on the command line by beginning the command
 line option with "\-+".
 .sp
@@ -567,6 +578,11 @@
 it is also used as a 
 .I lesskey
 file.
+.IP -K\fIcharset\fP
+Causes
+.I less
+to use this charset instead of a charset defined in the JLESSCHARSET or
+LESSCHARSET environment variable.
 .IP "-m or --long-prompt"
 Causes 
 .I less
@@ -622,11 +638,11 @@
 .IP "-P\fIprompt\fP or --prompt=\fIprompt\fP"
 Provides a way to tailor the three prompt
 styles to your own preference.
-This option would normally be put in the LESS environment
-variable, rather than being typed in with each 
+This option would normally be put in the LESS and JLESS environment
+variables, rather than being typed in with each 
 .I less
 command.
-Such an option must either be the last option in the LESS variable,
+Such an option must either be the last option in the LESS and JLESS variables,
 or be terminated by a dollar sign.
 -Ps followed by a string changes the default (short) prompt 
 to that string.
@@ -738,6 +754,9 @@
 .IP "-W or --HILITE-UNREAD"
 Like -w, but temporarily highlights the first new line after any 
 forward movement command larger than one line.
+.IP -XXX
+Causes mark characters to be used to represent wrong characters.
+By default, such wrong characters displayed as binary.
 .IP "-x\fIn\fP or --tabs=\fIn\fP"
 Sets tab stops every \fIn\fP positions.
 The default for \fIn\fP is 8.
@@ -767,6 +786,10 @@
 For example, if the screen is 24 lines, \fI-z-4\fP sets the 
 scrolling window to 20 lines.  If the screen is resized to 40 lines,
 the scrolling window automatically changes to 36 lines.
+.IP -Z
+Causes to give priority to the SJIS over the UJIS if a "japanese" was selected
+by the JLESSCHARSET environment variable.  The default value is
+to give priority to the UJIS over the SJIS.
 .IP -"\fIcc\fP\ or\ --quotes=\fIcc\fP
 Changes the filename quoting character.
 This may be necessary if you are trying to name a file
@@ -1066,8 +1089,15 @@
 .PP
 A "character set" is simply a description of which characters are to
 be considered normal, control, and binary.
-The LESSCHARSET environment variable may be used to select a character set.
-Possible values for LESSCHARSET are:
+The JLESSCHARSET and LESSCHARSET environment variables may be used to select
+a character set.  There is no difference between them in program of
+.I less.
+But I suppose you should use the JLESSCHARSET environment variable
+because not enhanced
+.I less
+will make errors if you use enhanced character set in 
+your LESSCHARSET environment variable.
+Possible values for them are:
 .IP ascii
 BS, TAB, NL, CR, and formfeed are control characters,
 all chars with values between 32 and 126 are normal,
@@ -1089,6 +1119,151 @@
 .IP utf-8
 Selects the UTF-8 encoding of the ISO 10646 character set.
 .PP
+And possible values for only JLESSCHARSET are:
+.IP iso7
+Multi character sets with the ISO 2022 code extension techniques
+in 7 bits are assumed.
+Characters with values between 128 and 255 are treated as binary.
+The level of implementation of
+.I Less
+is level 3 of ISO 2022.
+.IP iso8
+Multi character sets with the ISO 2022 code extension techniques
+in 8 bits are assumed.
+The level of implementation of
+.I Less
+is level 3 of ISO 2022.
+.IP jis
+Only Japanese character sets with the ISO 2022 code extension
+techniques in 7 bits are assumed.
+.IP ujis
+If characters has values between 32 and 127,
+the ASCII character set are assumed.
+If characters has values between 162 and 254,
+the JISX 0208 character set,
+a right half of the JISX 0201 character set and
+the JISX 0212 character set with the UJIS coding are assumed.
+Otherwise, characters are treated as binary.
+.IP euc
+Same as ujis.
+.IP sjis
+If characters has values between 32 and 127,
+the ASCII character set are assumed.
+If characters has values between 128 and 252,
+the JISX 0208 character set and
+a right half of the JISX 0201 character set are assumed.
+Otherwise, characters are treated as binary.
+.IP japanese
+All Japanese character sets, jis, ujis and sjis, are assumed.  But
+.I less
+output only the jis.
+.PP
+Japanese has several code sets (not character sets).
+Thus
+.I less
+must convert among them to display them correctly.
+Possible values with this conversion for only JLESSCHARSET are:
+.IP ujis-iso7
+The ujis and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP euc-iso7
+Same as ujis-iso7.
+.IP sjis-iso7
+The sjis and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP ujis-jis
+The ujis and jis are assumend.  But
+.I less
+output only the jis.
+.IP euc-jis
+Same as ujis-jis.
+.IP sjis-jis
+The sjis and jis are assumend.  But
+.I less
+output only the jis.
+.IP jis-ujis
+The jis and ujis are assumend.  But
+.I less
+output only the ujis.
+.IP jis-euc
+Same as jis-ujis.
+.IP jis-sjis
+The jis and sjis are assumend.  But
+.I less
+output only the sjis.
+.IP japanese-iso7
+The japanese and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP japanese-jis
+The japanese is assumend.  But
+.I less
+output only the jis.
+Same as japanese.
+.IP japanese-ujis
+The japanese is assumend.  But
+.I less
+output only the ujis.
+.IP japanese-euc
+Same as japanese-ujis.
+.IP japanese-sjis
+The japanese is assumend.  But
+.I less
+output only the sjis.
+.IP ujis-sjis
+The ujis is assumend.  But
+.I less
+output only the sjis.
+.IP euc-sjis
+Same as ujis-sjis.
+.IP sjis-ujis
+The sjis is assumend.  But
+.I less
+output only the ujis.
+.IP sjis-euc
+Same as sjis-ujis.
+.PP
+Other way to select a character set is to use the LANG environment variable.
+If it start with "ja_JP" or "japan",
+.I less
+read all Japanese coded characters as some Japanese character set,
+and a rest of the LANG environment variable specify output coding.
+.PP
+The ISO 2022 code extension techniques define
+4 planes to display many character sets easy.
+Default setting of planes is selected by
+the JLESSPLANESET environment variable.
+If the JLESSPLANESET vriable is equal to "japanese", "ujis" or "euc",
+.I less
+treat g1 plane as JISX 0208, g2 plane as JISX 0201 right half, g3 plane
+as JISX 0212.  If it is equal to "latin1", "latin2", "latin3", "latin4",
+"greek", "alabic", "hebrew", "cyrillic" or "latin5",
+.I less
+treat g1 plane as one of ISO 8859.
+Otherwise,
+.I less
+try to parse the JLESSPLANESET variable as 
+real escape sequences for setting up, and "\\e" in JLESSPLANESET
+is treated as escape code when parsing.
+.PP
+.I Less
+understand almost all escape sequence about character set
+in the ISO 2022 code extension techniques.  There are many escape sequences
+to select the character set.  On the one hand,
+.I less
+output only 6 escape sequences to select a character
+set: '^[(', '^[-', '^[$(', '^[$-', '^N' and '^O'.
+It means
+.I less
+is friendly to a terminal and a terminal emulator.
+.PP
+And there is special "character set" for keyboard inputs.
+The JLESSKEYCHARSET environment variable is used
+for such purpose.  Possible values of it are equal
+to the JLESSCHARSET environment variable.
+.PP
 If the LESSCHARSET environment variable is not set,
 the default character set is latin1.
 However, if the string "UTF-8" is found in the LC_ALL, LC_CTYPE or LANG
@@ -1216,6 +1391,8 @@
 Usually used at the end of the string, but may appear anywhere.
 .IP "%x"
 Replaced by the name of the next input file in the list.
+.IP "%K"
+Replaced by the name of the last non ASCII character set or code set.
 .PP
 If any item is unknown (for example, the file size if input
 is a pipe), a question mark is printed instead.
@@ -1395,6 +1572,8 @@
 Options which are passed to 
 .I less
 automatically.
+.IP JLESS
+same as the LESS environment variable.
 .IP LESSANSIENDCHARS
 Characters which are assumed to end an ANSI color escape sequence
 (default "m").
@@ -1402,8 +1581,14 @@
 Format for displaying non-printable, non-control characters.
 .IP LESSCHARDEF
 Defines a character set.
-.IP LESSCHARSET
+.IP JLESSCHARSET
 Selects a predefined character set.
+.IP LESSCHARSET
+Selects a predefined character set if JLESSCHARSET is not defined.
+.IP JLESSKEYCHARSET
+Selects a predefined character set for keyboard inputs.
+.IP JLESSPLANESET
+Selects a predefined plane set of the ISO 2022 code extension techniques.
 .IP LESSCLOSE
 Command line to invoke the (optional) input-postprocessor.
 .IP LESSECHO
@@ -1512,4 +1697,11 @@
 Mark Nudelman <marknu@flash.net>
 .br
 Send bug reports or comments to the above address or to bug-less@gnu.org.
+
+.SH PATCH
+Copyright (c) 1994-2000  Kazushi (Jam) Marukawa, Japanized routines only
+.br
+Comments about this part to: jam@pobox.com
+.br
+You may distribute under the terms of the Less License.
 
Index: less/lesskey.c
diff -u less/lesskey.c:1.1.1.17 less/lesskey.c:1.23
--- less/lesskey.c:1.1.1.17	Sun Oct 29 02:19:14 2000
+++ less/lesskey.c	Tue Oct 31 04:30:40 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -146,6 +152,9 @@
 	"undo-hilite",		A_UNDO_SEARCH,
 	"version",		A_VERSION,
 	"visual",		A_VISUAL,
+#if JAPANESE
+	"rotate-right",		A_ROT_RCODESET,
+#endif
 	NULL,			0
 };
 
Index: less/lesskey.nro
diff -u less/lesskey.nro:1.1.1.15 less/lesskey.nro:1.21
--- less/lesskey.nro:1.1.1.15	Sun Oct 29 02:19:16 2000
+++ less/lesskey.nro	Tue Oct 31 04:30:40 2000
@@ -215,6 +215,7 @@
 	v		visual 
 	!		shell 
 	+		firstcmd 
+	@		rotate-right 
 	H		help 
 	h		help 
 	V		version 
@@ -377,3 +378,9 @@
 .br
 Send bug reports or comments to the above address or to bug-less@gnu.org.
 
+.SH PATCH
+Copyright (c) 1994-2000  Kazushi (Jam) Marukawa, Japanized routines only
+.br
+Comments to: jam@pobox.com
+.br
+You may distribute under the terms of the Less License.
